package net.knarcraft.minstrel.command;

import net.knarcraft.minstrel.music.Song;
import net.knarcraft.minstrel.trait.MinstrelTrait;
import org.bukkit.command.Command;
import org.bukkit.command.CommandExecutor;
import org.bukkit.command.CommandSender;
import org.jetbrains.annotations.NotNull;

/**
 * The command for listing a minstrel's current songs
 */
public class ListSongsCommand implements CommandExecutor {

    private final MinstrelTrait minstrelTrait;

    /**
     * Instantiates a new list songs command
     *
     * @param minstrelTrait <p>The minstrel to run this command on</p>
     */
    public ListSongsCommand(MinstrelTrait minstrelTrait) {
        this.minstrelTrait = minstrelTrait;
    }

    @Override
    public boolean onCommand(@NotNull CommandSender sender, @NotNull Command command, @NotNull String label,
                             @NotNull String[] args) {
        StringBuilder builder = new StringBuilder();
        builder.append("Songs:").append("\n");
        for (Song song : minstrelTrait.getPlaylist().getSongs()) {
            builder.append(song).append("\n");
        }
        sender.sendMessage(builder.toString());
        return true;
    }

}
