package net.knarcraft.minstrel.listener;

import net.citizensnpcs.api.CitizensAPI;
import net.citizensnpcs.api.event.NPCRemoveEvent;
import net.citizensnpcs.api.npc.NPC;
import net.knarcraft.minstrel.trait.MinstrelTrait;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.player.PlayerJoinEvent;

/**
 * A listener for minstrel-relate events
 */
public class MinstrelListener implements Listener {

    /**
     * Listens for any players joining, and makes all minstrels play for them
     *
     * @param event <p>The triggered event</p>
     */
    @EventHandler
    public void playerJoinListener(PlayerJoinEvent event) {
        for (NPC npc : CitizensAPI.getNPCRegistry()) {
            if (npc.hasTrait(MinstrelTrait.class)) {
                MinstrelTrait minstrelTrait = npc.getTraitNullable(MinstrelTrait.class);
                minstrelTrait.getPlaylist().play(minstrelTrait, event.getPlayer());
            }
        }
    }

    /**
     * Listens for the deletion of any NPCs, and stops their music
     *
     * @param event <p>The triggered event</p>
     */
    @EventHandler
    public void npcDeletionListener(NPCRemoveEvent event) {
        NPC npc = event.getNPC();
        if (npc.hasTrait(MinstrelTrait.class)) {
            MinstrelTrait minstrelTrait = npc.getTraitNullable(MinstrelTrait.class);
            minstrelTrait.getPlaylist().stop();
        }
    }

}
